unit Coding;

interface

type
    bit=0..1;
//    fifteen_bytes=array[1..120]of bit;
//  seven_bytes=array[1..56]of bit;
    Code_komb=array[1..31]of bit;
    one_byte=array[1..8]of bit;
    Inf_Symb=array[1..16]of bit;
const
    M=4;
 ObrPoly:array[1..16] of bit=(1,0,0,0,1,1,1,1,1,0,1,0,1,1,1,1);

var
    ch:char;


procedure  Ostatok(var kod:Code_komb);
Procedure  AddMod_2(X,Y:Code_komb;var Result:Code_komb);
procedure  Rashiren_8_to_16_Byte(A:One_Byte;var B:Inf_Symb);
function   One_byte_to_ch(m:one_byte):char;
procedure  Ch_to_one_byte(u:char; var p:one_byte);
function   Coding_CharToString(S:char):string;
procedure  Rashiren_Inf_to_31(A:Inf_Symb;var B:Code_komb);
procedure  Inf_vs_Prov(A:Inf_Symb;var B:Code_komb);
Procedure  Code_31_To_Massive_31_byte(CodeStr:ShortString;var A:Code_komb);
function   Code_Massive_31_To_Str(A:Code_komb):ShortString;
procedure  IspravlenError(var A:Code_komb);

implementation
 uses unit4;

Procedure AddMod_2(X,Y:Code_komb;var Result:Code_komb);
var i:integer;
begin  for  i:=1 to 31 do
       Result[i]:= X[i] xor Y[i];
end;


procedure Rashiren_Inf_to_31(A:Inf_Symb;var B:Code_komb);
var i:integer;
begin    for i:=1 to 16 do
             B[i]:=A[i];
         for i:=17 to 31 do
              B[i]:=0;
end;


procedure Inf_vs_Prov(A:Inf_Symb;var B:Code_komb);
var //C: Code_komb;
    i:integer;
begin
        Ostatok(B);
  //      B:=C;
        for i:= 1 to 16 do
              B[i]:=A[i];
end;


procedure  Rashiren_8_to_16_Byte(A:One_Byte;var B:Inf_Symb);
var i :integer;
begin   for i:=1 to 8 do
         B[i]:=0;
        for i:=9 to 16 do
        B[i]:=A[i-8];
end;

 procedure ostatok(var kod:Code_komb);
  var
    n,f,temp:integer;
  begin
        f:=1;
        while f<=16 do
            begin
               if kod[f]=1 then
                  begin
                    n:=1;
                    for temp:=f to f+15 do
                        begin
                           kod[temp]:=kod[temp] xor ObrPoly[n];
                           n:=n+1;
                        end;
                  end;
               f:=f+1;
            end;
  end;

function one_byte_to_ch(m:one_byte):char;
  var
     x,y,e:integer;
  begin
        x:=0;
        e:=1;
        for y:=8 downto 1 do
            begin
                if m[y]=1 then
                         x:=x+e;
                e:=e*2;
            end;
        one_byte_to_ch:=chr(x);
  end;

 procedure ch_to_one_byte(u:char; var p:one_byte);
  var
       t,i:integer;
  begin
                       t:=ord(u);
                for i:=8 downto 1 do
                     begin
                         p[i]:=t mod 2;
                         t:=t div 2;
                     end;
  end;

function Coding_CharToString(S:char):string;
var
     PByte:One_Byte;
     PInf:Inf_Symb;
     PCode:Code_komb;
     i:integer;
     SS:String;
begin
        ch_to_one_byte(S,PByte);
      Rashiren_8_to_16_Byte(PByte,PInf);
      Rashiren_Inf_to_31(PInf,PCode);
        Inf_vs_Prov(PInf,PCode);
      for i:=1 to 31 do
         begin  if PCode[i]=1 then
            begin  SS:=SS+'1';
                   Coding_CharToString:= SS;
            end
                else
            begin  SS:=SS+'0';
                   Coding_CharToString:=SS;
            end
         end;
end;


Procedure  Code_31_To_Massive_31_byte(CodeStr:ShortString;var A:Code_komb);
var i:integer;
begin  For i:=1 to 31 do
         begin   if CodeStr[i]='1' then A[i]:=1;
                 if CodeStr[i]='0' then A[i]:=0;
         end;
end;

function  Code_Massive_31_To_Str(A:Code_komb):ShortString;
var i:integer;
    str:Shortstring;
begin    Str:='';
         for i:=1 to 31 do
          begin  if A[i]=1 then Str:=Str+'1';
                 if A[i]=0 then Str:=Str+'0';
          end;
          Code_Massive_31_To_Str:=Str;
end;

procedure  IspravlenError(var A:Code_komb);
label 1;
var n:integer;
    B,C:Code_komb;
    MovCounter:integer;

function Ves(Mass:Code_Komb):integer;
var n,i:integer;
begin   n:=0;
        for i:=1 to 31 do
             if Mass[i]=1 then n:=n+1;
        Ves:=n;
end;

Procedure MovLeft(var Mass:Code_komb);
var   Saver: bit;
      i:integer;
begin
      Saver:=Mass[1];
      for i:=2 to 31 do Mass[i-1]:=Mass[i];
        Mass[31]:=Saver;
        MovCounter:=MovCounter+1;
end;

Procedure MovRight(var Mass:Code_komb);
var   Saver: bit;
      i:integer;
begin
      Saver:=Mass[31];
      for i:=30 downto 1 do Mass[i+1]:=Mass[i];
        Mass[1]:=Saver;
        MovCounter:=MovCounter-1;
end;
{===================================================}
begin   MovCounter:=0;
       flagVsegoIspravl:=false;
        B:=A;
        C:=A;
       Ostatok(A);
       n:=Ves(A);
       If n = 0 then Goto 1;
       if n <= 3 then begin
                      AddMod_2(B,A,C);
        flagVsegoIspravl:=true;
        VsegoErrors:= VsegoErrors+1;
                      Goto 1;
                      end;
      while n > 3 do
         begin  MovLeft(B);
                A:=B;
                Ostatok(A);
                n:=Ves(A);
                If MovCounter>31 then Goto 1;
         end;
         AddMod_2(B,A,C);
         while MovCounter<>0 do MovRight(C);
        flagVsegoIspravl:=true;
        VsegoErrors:= VsegoErrors+1;
1:  A:=C;
  end;


end.
