unit Unit4;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Gauges, MDIFrame, ComCtrls, StdCtrls ,coding, unit5,
  unit7 ,Kanal;

type
  TDecode = class(TForm)
    OpenDialog1: TOpenDialog;
    Gauge1: TGauge;
    GroupBox1: TGroupBox;
    DecodeButton: TButton;
    StatusBar1: TStatusBar;
    Label1: TLabel;
    StaticText1: TStaticText;
    StaticText2: TStaticText;
    StaticText3: TStaticText;
    StaticText4: TStaticText;
    StaticText5: TStaticText;
    StaticText6: TStaticText;
    StaticText7: TStaticText;
    StaticText8: TStaticText;
    VsegoBitLabel: TLabel;
    VsegoSymbLabel: TLabel;
    VsegoErrorsLabel: TLabel;
    VsegoIsprLabel: TLabel;
    VsegoNeIsprLabel: TLabel;
    Button1: TButton;
    Button2: TButton;
    Procedure AddFileToSpis;
    procedure DecodeButtonClick(Sender: TObject);
    Function BitInFile(FileName:string):longint;
    procedure Decoding(FileName:string) ;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Decode: TDecode;
  VsegoBit     :Longint;
  VsegoDecSymb :integer;
  VsegoErrors  :integer;
  VsegoIspravl :integer;
  FlagVsegoIspravl:boolean;
  VsegoNeIspravl :integer;


implementation
 // uses Kanal;
{$R *.DFM}

Procedure TDecode.AddFileToSpis;
var   f:file of TCodeArray;
    //s:string;
    Temp,Top:PCodeArray;
begin
       if OpenDialog1.Execute then
          SourceFile:= OpenDialog1.FileName;
          if  SourceFile='' then Exit;
        Label1.Caption:= SourceFile;
        Repaint;
       SetLength(SourceFile,Length(SourceFile)-3);
       SourceFile:=SourceFile+'cod';
       AssignFile(f,SourceFile);
       Reset(f);
          New(CodeArray);
          read(f,CodeArray^);
          Top:=CodeArray;
   while not EOF(f) do
        begin
     while Top^.Next<>nil do Top:=Top^.Next;
           New(Temp);
           read(f,Temp^);
           Temp^.Next := nil;
             Top^.Next:= Temp;
             Temp^.Prev:=Top;
             Top:=CodeArray;
        end;

       CloseFile(f);
end;

function TDecode.BitInFile(FileName:string):longint;
var  f:textfile;
     n:longint;
     s:Char;
begin    if filename='' then
           begin  BitInFIle:=0;
                  Exit;
           end;
         SetLength(FileName,Length(FileName)-3);
   //      FileName:=FileName+'_';
         FileName:=FileName+'bch';
         AssignFile(f,FileName);
         reset(f);
         n:=0;
        While not EOf(f) do
           begin
                 N:=N+1;
  { !!!}  Read(f,s);
           end;
  //            N:=N-1;
     BitInFile:= N ;
         CloseFile(f);

end;

procedure TDecode.DecodeButtonClick(Sender: TObject);
Var s:String;
begin
      AddFileToSpis;
      VsegoBit:=BitInFile(SourceFile);
      Str(VsegoBit,S);
      VsegoBitLabel.Caption:=S;
      VsegoDecSymb:= round(VsegoBit/31);
      Str(VsegoDecSymb,S);
       VsegoSymbLabel.Caption:=S;
       VsegoErrors:=0;
     Str(VsegoErrors,S);
       Decode.VsegoErrorsLabel.Caption:=S;
         VsegoIspravl:=0;
     Str(VsegoIspravl,S);
       Decode.VsegoIsprLabel.Caption:=S;
         VsegoNeIspravl:=0;
     Str(VsegoNeIspravl,S);
       Decode.VsegoNeIsprLabel.Caption:=S;

       Decode.Repaint;
       if VsegoBit=0 then Exit;
       Decoding(SourceFile);


      DeleteSpis(CodeArray);
end;

Procedure  TDecode.Decoding(FileName:string) ;
var  f_in,f_out:TextFIle;
   K:Code_komb;
     SS:String;
     SSS:ShortString;
     S:String[31];
     Storage:PCodeArray;
     Writing:boolean;

begin      writing:=false;
           VsegoErrors:=0;
           VsegoIspravl:=0;
           VsegoNeIspravl:=0;
    Decode.Gauge1.MaxValue:=VsegoDecSymb;
           SetLength(FileName,Length(FileName)-3);
           SS:=FileName;
//         FileName:=FileName+'_';
         FileName:=FileName+'bch';
         AssignFile(f_in,FileName);
         SS:=SS+'dcd';
         AssignFile(f_out,SS);
         reset(f_in);
         rewrite(f_out);
Decode.StatusBar1.SimpleText:=
 '  ...   ...';
  while not EOF(f_in) do
     begin
      read(f_in,S);
  Decode.Gauge1.AddProgress(1);
  Code_31_To_Massive_31_byte(S,K);
  IspravlenError(K);
   SSS:=Code_Massive_31_To_Str(K);

      Storage:=CodeArray;
    While CodeArray<>nil do
        begin
             if CodeArray^.Code=SSS then
                  begin  write(f_out,CodeArray^.Symbol);
                         Writing:=true;
                         Break;
                  end ;
        CodeArray:=CodeArray^.Next;
        end;
        CodeArray:=Storage;
   if writing=false then
         begin
               write(f_Out,'_');
  VsegoNeIspravl:=VsegoNeIspravl+1;
  VsegoErrors:=VsegoErrors+1;
         end;
    if (writing=true)and(flagVsegoIspravl=true) then
          VsegoIspravl:=VsegoIspravl+1;


       Writing:=false;
     end;
     Str(VsegoErrors,SS);
     Decode.VsegoErrorsLabel.Caption:=SS;
     Str(VsegoIspravl,SS);
     Decode.VsegoIsprLabel.Caption:=SS;
     Str(VsegoNeIspravl,SS);
     Decode.VsegoNeIsprLabel.Caption:=SS;
     Decode.Gauge1.Progress:=0;
Decode.StatusBar1.SimpleText:='.';
         CloseFile(f_in);
         CloseFile(f_out);
end;



procedure TDecode.Button1Click(Sender: TObject);
begin
      Decode.Close;
end;

procedure TDecode.Button2Click(Sender: TObject);
begin
with TForm5.Create(Application) do
        try
         ShowModal;
        finally
         Free;
        end;
//    Form5.Show;

end;

end.
